import {
  createSelector,
  MemoizedSelector,
} from '@ngrx/store';

import { ErrorResponse } from 'packages/commons/service/error-response';
import { Domain } from 'packages/domain/model';
import { Member } from '../../model';

export interface State {
  isSignin: boolean;
  error: ErrorResponse | null;
  isPending: boolean;
  member: Member | null;
  domain: Domain | null;
}

export const initialState: State = {
  isSignin: false,
  error: null,
  isPending: false,
  member: null,
  domain: null,
};

export class StateSelector {
  public constructor(private _selector: MemoizedSelector<any, any>) {
  }

  public isSignin = createSelector(this._selector, (state: State) => state.isSignin);
  public getMember = createSelector(this._selector, (state: State) => state.member);
  public getDomain = createSelector(this._selector, (state: State) => state.domain);
  public getError = createSelector(this._selector, (state: State) => state.error);
  public isPending = createSelector(this._selector, (state: State) => state.isPending);
}
