import {
  createSelector,
  createFeatureSelector,
  ActionReducerMap,
} from '@ngrx/store';

import { MODULE } from '../member.constant';

import * as AuthStore from './auth';
import * as SignupStore from './signup';

export interface State {
  auth: AuthStore.State;
  signup: SignupStore.Signup;
}

export const REDUCERS = {
  auth: AuthStore.reducer,
  signup: SignupStore.reducer,
};

export const EFFECTS = [
  AuthStore.Effects,
  SignupStore.Effects,
];

export const selectMemberState = createFeatureSelector<State>(MODULE.name);

export const selectMemberAuthState = createSelector(
  selectMemberState,
  (state: State) => state.auth
);

export const AuthSelector = new AuthStore.StateSelector(selectMemberAuthState);


export const selectMemberSignupState = createSelector(
  selectMemberState,
  (state: State) => state.signup
);
